
//**************************************************************************
//**
//** h_hubmsg.h : Heretic 2 : Raven Software, Corp.
//**
//** $Revision: 373 $
//** $Date: 2009-05-19 21:14:28 +0300 (Tue, 19 May 2009) $
//**
//**************************************************************************

#ifndef _H_HUBMSG
#define _H_HUBMSG

#define MAX_INTRMSN_MESSAGE_SIZE	1024

const char *GetClusterText(int sequence);
const char *GetFinaleText (int sequence);

/* Hardcoded Cluster Ending Messages for Version 1.0 WAD files: ----------*/
/* h_hubmsg.c  -----------------------------------------------------------*/

#define TXT_CLUS1MSG	"HAVING PASSED THE SEVEN PORTALS\n"		\
			"WHICH SEALED THIS REALM, A VAST\n"		\
			"DOMAIN OF HARSH WILDERNESS STRETCHES\n"	\
			"BEFORE YOU. FIRE, ICE, AND STEEL HAVE\n"	\
			"TESTED YOU, BUT GREATER CHALLANGES\n"		\
			"REMAIN AHEAD. THE DENSE TANGLE OF\n"		\
			"FOREST SURELY HIDES HOSTILE EYES,\n"		\
			"BUT WHAT LIES BEYOND WILL BE WORSE.\n\n"	\
			"BARREN DESERT, DANK SWAMPS AND\n"		\
			"MUSTY CAVERNS BAR YOUR WAY, BUT YOU\n"		\
			"CANNOT LET ANYTHING KEEP YOU FROM\n"		\
			"YOUR FATE, EVEN IF YOU MIGHT COME\n"		\
			"TO WISH THAT IT WOULD.\n\n"			\
			"AND BEYOND, FLICKERING IN THE\n"		\
			"DISTANCE, THE EVER-SHIFTING WALLS\n"		\
			"OF THE HYPOSTYLE SEEM TO MOCK\n"		\
			"YOUR EVERY EFFORT."

#define TXT_CLUS2MSG	"YOUR MIND STILL REELING FROM YOUR\n"		\
			"ENCOUNTERS WITHIN THE HYPOSTYLE, YOU\n"	\
			"STAGGER TOWARD WHAT YOU HOPE IS\n"		\
			"A WAY OUT, THINGS SEEM TO MOVE FASTER\n"	\
			"AND FASTER, YOUR VISION BLURS AND\n"		\
			"BEGINS TO FADE...\n"				\
			"AS THE WORLD COLLAPSES AROUND YOU,\n"		\
			"THE BRIGHTNESS OF A TELEPORTAL\n"		\
			"ENGULFS YOU. A FLASH OF LIGHT AND THEN\n"	\
			"YOU CLIMB WEARILY TO YOUR FEET.\n\n"		\
			"YOU STAND ATOP A HIGH TOWER, AND\n"		\
			"FROM BELOW COME THE SCREAMS OF THE\n"		\
			"DAMNED. YOU STEP FORWARD, AND\n"		\
			"INSTANTLY THE SOUND OF DEMONIC\n"		\
			"CHANTING CHILLS YOUR BLOOD.\n"			\
			"BY ALL THE GODS OF DEATH! WHAT PLACE\n"	\
			"HAVE YOU COME TO? BY ALL THE GODS OF\n"	\
			"PAIN, HOW WILL YOU EVER FIND YOUR\n"		\
			"WAY OUT?"

#define TXT_CLUS3MSG	"THE MIGHTIEST WEAPONS AND ARTIFACTS\n"		\
			"OF THE ANCIENTS BARELY SUFFICED TO\n"		\
			"DEFEAT THE HERESIARCH AND HIS\n"		\
			"MINIONS, BUT NOW THEIR FOUL REMAINS\n"		\
			"LIE STREWN AT YOUR FEET. GATHERING\n"		\
			"THE LAST OF YOUR STRENGTH, YOU\n"		\
			"PREPARE TO ENTER THE PORTAL WHICH\n"		\
			"LEADS FROM THE HERESIARCH'S INNER\n"		\
			"SANCTUM.\n\n"					\
			"ABOVE YOU, THE RAMPARTS OF AN\n"		\
			"IMMENSE CASTLE LOOM. SILENT TOWERS\n"		\
			"AND BARE WALLS SURROUND A SINGLE\n"		\
			"SPIRE OF BLACK STONE, WHICH SQUATS\n"		\
			"IN THE CENTER OF THE CASTLE LIKE A\n"		\
			"BROODING GIANT. FIRE AND SHADOW\n"		\
			"TWIST BEHIND GAPING WINDOWS, DOZENS\n"		\
			"OF BALEFUL EYES GLARING DOWN UPON\n"		\
			"YOU.\n"					\
			"SOMEWHERE WITHIN, YOUR ENEMIES ARE\n"		\
			"WAITING..."

#define TXT_CLUS4MSG	"\"... AND HE SHALL JOURNEY INTO THE\n"		\
			"REALMS OF THE DEAD, AND CONTEST WITH\n"	\
			"THE FORCES THEREIN, UNTO THE VERY\n"		\
			"GATES OF DESPAIR, BUT WHETHER HE\n"		\
			"SHALL RETURN AGAIN TO THE WORLD OF\n"		\
			"LIGHT, NO MAN KNOWS.\"\n"			\
			"\n\n\n\n\n"					\
			"DAMN."

#define TXT_CLUS5MSG	"PLEASE EMAIL THE DEVELOPERS\n"			\
			"AND TELL THEM HOW YOU FOUND\n"			\
			"THIS MESSAGE IN AS MUCH DETAIL\n"		\
			"AS POSSIBLE SO THEY CAN PUT\n"			\
			"THE RIGHT MESSAGE HERE.\n\n"			\
			"THANKS."

#define TXT_WIN1MSG	"WITH A SCREAM OF AGONY YOU ARE\n"		\
			"WRENCHED FROM THIS WORLD INTO\n"		\
			"ANTOHER, EVERY PART OF YOUR BODY\n"		\
			"WREATHED IN MYSTIC FIRE. WHEN YOUR\n"		\
			"VISION CLEARS, YOU FIND YOURSELF\n"		\
			"STANDING IN A GREAT HALL, FILLED\n"		\
			"WITH GHOSTLY ECHOES AND MENACING\n"		\
			"SHADOWS. IN THE DISTANCE YOU CAN\n"		\
			"SEE A RAISED DAIS, AND UPON IT THE\n"		\
			"ONLY SOURCE OF LIGHT IN THIS WORLD."

#define TXT_WIN2MSG	"THIS CAN ONLY BE THE CHAOS SPHERE,\n"		\
			"THE SOURCE OF KORAX'S POWER. WITH\n"		\
			"THIS, YOU CAN CREATE WORLDS... OR\n"		\
			"DESTROY THEM. BY RIGHTS OF BATTLE\n"		\
			"AND CONQUEST IT IS YOURS, AND WITH\n"		\
			"TREMBLING HANDS YOU REACH TO GRASP\n"		\
			"IT. PERHAPS, NOW, A NEW PLAYER WILL\n"		\
			"JOIN THE COSMIC GAME OF POWER. LIKE\n"		\
			"THE PAWN WHO IS PROMOTED TO QUEEN,\n"		\
			"SUDDENLY THE VERY REACHES OF THE\n"		\
			"BOARD SEEM TO BE WITHIN YOUR GRASP."

#define TXT_WIN3MSG	"BUT THERE ARE OTHER PLAYERS MIGHTIER\n"	\
			"THAN YOU, AND WHO CAN KNOW THEIR\n"		\
			"NEXT MOVES?"

#endif	/* _H_HUBMSG */

